%global _hardened_build 1
%global distver 1_2-RELEASE
%global selinux_types %(%{__awk} '/^#[[:space:]]*SELINUXTYPE=/,/^[^#]/ { if ($3 == "-") printf "%s ", $2 }' /etc/selinux/config 2>/dev/null)
%global selinux_variants %([ -z "%{selinux_types}" ] && echo mls targeted || echo %{selinux_types})

Name:           gogoc
Version:        1.2
Release:        45%{?dist}
Summary:        IPv6 TSP client for gogo6

Group:          System Environment/Daemons
# The entire source code is BSD except gogoc-tsp/include/net_tcp6.c
License:        BSD and GPLv2
URL:            http://gogonet.gogo6.com/page/freenet6-services
Source0:        http://content.gogo6.com/%{name}-%{distver}.tar.gz
Source1:        %{name}.service
Source2:        %{name}-tmpfiles.conf
Source3:        %{name}.fc
Source4:        %{name}.if
Source5:        %{name}.te
Patch1:         %{name}-1.2-dirpath.patch
Patch2:         %{name}-1.2-gcc_4.6_compile_fix.patch
Patch3:         %{name}-1.2-gogoc_conf_5.patch
# Patch4: https://bugs.launchpad.net/ubuntu/+source/gw6c/+bug/418176
Patch4:         %{name}-1.2-lp418176_client_v4.patch
Patch6:         %{name}-1.2-kill_radvd.patch
Patch7:         %{name}-1.2-debug_info.patch
# Patch8: https://bugzilla.redhat.com/show_bug.cgi?id=983052
Patch8:         %{name}-1.2-bz983052_adjust_output_scraping_to_match_current_ifconfig.patch
Patch9:         %{name}-1.2-change_tmp_file.patch
# Patch10: https://bugzilla.redhat.com/show_bug.cgi?id=1063272
Patch10:        %{name}-1.2-use_iproute.patch

BuildRequires:  openssl-devel
BuildRequires:  systemd
BuildRequires:  checkpolicy
BuildRequires:  selinux-policy-devel
BuildRequires:  /usr/share/selinux/devel/policyhelp
BuildRequires:  hardlink

Requires:       radvd
Requires:       iproute
%if "%{_selinux_policy_version}" != ""
Requires:      selinux-policy >= %{_selinux_policy_version}
%endif
Requires(post): systemd
Requires(post): /usr/sbin/semodule
Requires(post): /sbin/fixfiles
Requires(post): policycoreutils-python-utils
Requires(preun): systemd
Requires(postun): systemd
Requires(postun): /usr/sbin/semodule
Requires(postun): policycoreutils-python-utils

%description
TSP is a control protocol used to establish and maintain static tunnels.
The gogoCLIENT is used on the host computer to connect to a tunnel broker
using the TSP protocol and to get the information for its IPv6 tunnel.
When it receives the information for the tunnel, the gogoCLIENT creates the 
static tunnel on its operating system.
You can setup a dynamic tunnel anonymously, but if you want a static prefix
you need an account in Freenet6 http://gogonet.gogo6.com/page/freenet6-account

%prep
%setup -q -n %{name}-%{distver}
%patch1 -p1 -b .dirpath
%patch2 -p1 -b .gcc_4.6_compile_fix
%patch3 -p1 -b .gogoc_conf_5
%patch4 -p1 -b .lp418176_client_v4
%patch6 -p1 -b .kill_radvd
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
mkdir SELinux
cp -p %{SOURCE3} %{SOURCE4} %{SOURCE5} SELinux

%build
CFLAGS="%{optflags}"; export CFLAGS
CXXFLAGS="%{optflags}"; export CXXFLAGS
LDFLAGS="%{__global_ldflags}"; export LDFLAGS
make -j1 all
cd SELinux
for selinuxvariant in %{selinux_variants}
do
  make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile
  mv %{name}.pp %{name}.pp.${selinuxvariant}
  make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile clean
done
cd -

%install
make installdir=%{buildroot}%{_prefix} install
# Directories that need to be packaged
install -d %{buildroot}%{_datadir} \
           %{buildroot}%{_sysconfdir}/sysconfig \
           %{buildroot}%{_sysconfdir}/%{name}/template \
           %{buildroot}%{_unitdir} \
           %{buildroot}%{_sharedstatedir}/%{name} \
           %{buildroot}%{_localstatedir}/run/%{name} \
           %{buildroot}%{_localstatedir}/log/%{name}
# Systemd unit file
install -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}
# Copy the Linux shell script to where it's needed
cp -p %{buildroot}%{_datadir}/%{name}/template/linux.sh %{buildroot}%{_sysconfdir}/%{name}/template/linux.sh
# Ghost files
touch %{buildroot}%{_sharedstatedir}/%{name}/gogockeys.pub
touch %{buildroot}%{_sharedstatedir}/%{name}/tsp-last-server.txt
touch %{buildroot}%{_sharedstatedir}/%{name}/tsp-broker-list.txt
touch %{buildroot}%{_localstatedir}/run/%{name}/%{name}-rtadvd.conf
touch %{buildroot}%{_localstatedir}/run/%{name}/%{name}-tmp.log
# Remove unneeded files
rm -f %{buildroot}%{_sysconfdir}/%{name}/%{name}.conf.sample
rm -rf %{buildroot}%{_datadir}/%{name}
# The config file can contain passwords, protect it
chmod 0640 %{buildroot}%{_sysconfdir}/%{name}/%{name}.conf
# Tmpfiles
mkdir -p %{buildroot}%{_tmpfilesdir}
install -m 0644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/%{name}.conf
# SELinux policy
cd SELinux
for selinuxvariant in %{selinux_variants}
do
  install -d %{buildroot}%{_datadir}/selinux/${selinuxvariant}
  install -p -m 644 %{name}.pp.${selinuxvariant} \
    %{buildroot}%{_datadir}/selinux/${selinuxvariant}/%{name}.pp
done
cd -
/usr/sbin/hardlink -cv %{buildroot}%{_datadir}/selinux

%post
%systemd_post %{name}.service

# Remove old SELinux file context
semanage fcontext -d -t radvd_etc_t '%{_localstatedir}/run/%{name}/%{name}-rtadvd.conf' 2>/dev/null || :

# Install SELinux policy
for selinuxvariant in %{selinux_variants}
do
  /usr/sbin/semodule -s ${selinuxvariant} -i \
    %{_datadir}/selinux/${selinuxvariant}/%{name}.pp &> /dev/null || :
done
# http://danwalsh.livejournal.com/10607.html
semanage port -a -t gogoc_port_t -p tcp 3653 >/dev/null 2>&1 || :
semanage port -a -t gogoc_port_t -p udp 3653 >/dev/null 2>&1 || :
/sbin/fixfiles -R %{name} restore || :

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

# Remove SELinux policy
if [ $1 -eq 0 ] ; then
  semanage port -d -p tcp 3653 >/dev/null 2>&1 || :
  semanage port -d -p udp 3653 >/dev/null 2>&1 || :
  for selinuxvariant in %{selinux_variants}
  do
    /usr/sbin/semodule -s ${selinuxvariant} -r %{name} &> /dev/null || :
  done
fi


%files
%doc README SELinux/*
%license CLIENT-LICENSE.TXT
%{_mandir}/man5/%{name}.conf.5.gz
%{_mandir}/man8/%{name}.8.gz
%config(noreplace) %{_sysconfdir}/%{name}
%{_tmpfilesdir}/%{name}.conf
%dir %{_sharedstatedir}/%{name}
%ghost %{_sharedstatedir}/%{name}/tsp-last-server.txt
%ghost %{_sharedstatedir}/%{name}/gogockeys.pub
%ghost %{_sharedstatedir}/%{name}/tsp-broker-list.txt
%dir %{_localstatedir}/run/%{name}
%ghost %{_localstatedir}/run/%{name}/%{name}-rtadvd.conf
%ghost %{_localstatedir}/run/%{name}/%{name}-tmp.log
%dir %{_localstatedir}/log/%{name}
%{_bindir}/%{name}
%{_unitdir}/%{name}.service
%{_datadir}/selinux/*/%{name}.pp

%changelog
* Mon Sep 07 2015 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-45
- Drop old _selinux_policy_version hack
- Hide errors while removing ports from the policy

* Fri Jul 24 2015 Tomas Radej <tradej@redhat.com> - 1.2-44
- Updated dep on policycoreutils-python-utils

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-43
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Apr 09 2015 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-42
- Use license macro

* Mon Jan 05 2015 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-41
- Remove PrivateDevices from service unit. Fixes #1178573

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-40
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-39
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Apr 29 2014 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-38
- Add PrivateDevices to service unit

* Wed Feb 26 2014 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-37
- Allow gogoc to manage log files in SELinux policy. Bug #1070235

* Mon Feb 17 2014 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-36
- Use iproute tools to configure tunnel. Bug #1063272

* Tue Feb 04 2014 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-35
- Use _tmpfilesdir macro

* Sat Jan 04 2014 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-34
- Allow name_connect to TCP port. Bug #1047099

* Mon Oct 07 2013 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-33
- Do not hardcode SELinux version dependency. See bug #999584

* Thu Aug 22 2013 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-32
- Update SELinux policy to 1.0.3

* Thu Aug 22 2013 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-31
- Fix selinux-policy dependency
- Fix patches to apply cleanly

* Wed Aug 21 2013 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-30
- Update SELinux policy to 1.0.2
- Remove reference to strict policy
- Change tmp file location to /var/run/gogoc

* Sun Aug 18 2013 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-29
- Add SELinux gogoc_etc_t type

* Tue Aug 13 2013 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-28
- Add SELinux policy
- Use PID file and systemctl to stop radvd

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-27
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jul 12 2013 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-26
- Adjust output scraping to match current ifconfig. Closes bug #983052,
  thanks to Frank Dana

* Tue May 28 2013 Juan Orti Alcaine <jorti@fedoraproject.org> - 1.2-25
- Add startup options via environment variable in service unit file

* Thu Apr 25 2013 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-24
- Fix PIE compilation. Closes bug #955282

* Fri Feb 08 2013 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-23
- Remove symlinked directories from ReadOnlyDirectories in unit file

* Mon Dec 17 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-22
- Remove DeviceAllow from unit file

* Fri Dec 14 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-21
- Fix policycoreutils-python dependency
- Add security measures in unit file: PrivateTmp, CapabilityBoundingSet,
  InaccessibleDirectories, ReadOnlyDirectories and DeviceAllow

* Tue Aug 21 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-20
- Add systemd macros. Fix #850133

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed Jul 04 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-18
- Remove sysconfig file

* Thu Jun 28 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-17
- Fix unit file documentation entry
- Update Source URL

* Wed Jun 27 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-16
- Add documentation to systemd service file
- Define variable as global
- Remove unneeded BuildRequires

* Mon Apr 16 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-15
- Hardened build
- Remove unnecesary datadir
- Add missing systemd-units build dependency

* Mon Apr 16 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-14
- Description updated
- Change variable to global
- Don't remove log files while uninstalling

* Tue Feb 14 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-13
- Fix tmpfiles directory creation

* Mon Feb 13 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-12
- Revert FSF address patch
- Update license information

* Mon Feb 13 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-11
- Fix FSF postal address

* Mon Feb 13 2012 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-10
- Honor RPM_OPT_FLAGS

* Thu Nov 24 2011 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-9
- Add tmpfiles directory creation

* Tue Sep 20 2011 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-8
- fixed debug symbols

* Mon Sep 19 2011 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-7
- spec file clean up
- systemd service fix

* Wed Sep 14 2011 Juan Orti Alcaine <j.orti.alcaine@gmail.com> - 1.2-6
- add Debian patches
- add systemd service
- license changed to BSD
